﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;

namespace InterfazRehabilitacion
{
    class Alarma
    {
        bool Visible;
        Vector2 Position = new Vector2(300, 40);
        Rectangle Rectangle;
        Texture2D Texture;
        public float Time=0;
        public int Count =4 ;
        public bool Finish=false;
        int num;

        public void Load(ContentManager Content)
        {
            this.Texture = Content.Load<Texture2D>("Alarma");
            Rectangle = new Rectangle((int)this.Position.X, (int)this.Position.Y, this.Texture.Width*2, this.Texture.Height*2);
        }

        public void Update(GameTime gameTime)
        {
            //if (Time > 0.5)
            //    num = 1;
            //else if (Time < 0)
            //    num = 0;


            if (Count > 0)
            {
                if (num == 1)
                {
                    Time -=(float)gameTime.ElapsedGameTime.TotalSeconds;
                    Visible = true;
                    if (Time < 0)
                    {
                        num = 0;
                        Count --;
                    }
                }
                else                 
                {
                    if (Time > 0.5)
                        num = 1;
                        Time += (float)gameTime.ElapsedGameTime.TotalSeconds;
                        Visible = false;
                   // Count -= (int)gameTime.ElapsedGameTime.TotalSeconds;
                }
                //Time += (float)gameTime.ElapsedGameTime.TotalSeconds;
            }

            if (Count == 0)
            {
                this.Finish = true;
                this.Visible = false;
            }
        }

        public void Draw(SpriteBatch spriteBatch)
        {
            if (Visible == true)
                spriteBatch.Draw(this.Texture, this.Rectangle, Color.White);
            else
            { }
        }
    }
}
