﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace InterfazRehabilitacion
{
    public partial class Control : Form
    {
        string RxString;
        string[] Palabras;
        public float PositionVariable=0;
        float PositionVariable2 = 0;
        float PositionVariable3 = 0;
        public float PositionActual = 0;
        float PositionAnterior;
        float PositionAnterior2;

        public bool antsOut=false;

        public int Tiempo=200;
        public int Number = 4;
        public int HojaDis = 10;
        public int AntFrec = 10;
        public int SpiderFrec = 2;

        public int pointsAnts;
        public int pointsSpider;
        public int pointsWorms;

        public bool Fin;


        public Control()
        {
            InitializeComponent();
        }

        public float Position
        {
            get { return PositionActual; }
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            SerialCOM.Checked();
        }

        private void Control_Load(object sender, EventArgs e)
        {
            SerialCOM.cBPuertos = checkBox1;
            SerialCOM.cmbPuertos = comboBox1;
            SerialCOM.Puerto = serialPort1;
            SerialCOM.timer = timer1;
            SerialCOM.busca_puertos(ref comboBox1);
        }

        private void button1_Click(object sender, EventArgs e)
        {
         SerialCOM.enviar(textBox5.Text);
        }

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            try
            {
                if (serialPort1.IsOpen)
                    RxString = serialPort1.ReadLine();
                this.BeginInvoke(new EventHandler(DisplayText));
                
            }
            catch
            {
              //  MessageBox.Show("ERROR");
            }
        }

        private void DisplayText(object sender, EventArgs e)
        {
            //   ReadSerial.Text = RxString;

        }

        int i;
        private void timer1_Tick(object sender, EventArgs e)
        {
            try
            {
                SerialCOM.enviar("-");
                Palabras = SerialCOM.timerString(RxString);
                textBox_Flex.Text = Palabras[0];
                textBox_Des.Text = Palabras[1];
                textBox_Pos.Text = Palabras[2];
                textBox_Des2.Text = Palabras[3];
                textBox_Pos2.Text = Palabras[4];
                textBox_e.Text = Palabras[5];
                textBox_PWM.Text = Palabras[6];
                textBox_e2.Text = Palabras[7];
                textBox_PWM2.Text = Palabras[8];

                if (Fin == true)
                    Resultados();



                try
                {
               //     if (int.Parse(textBox_Flex.Text) < 300)
               //         textBox_Flex.Text = "" + 300;
                    progressBar1.Value = int.Parse(textBox_Flex.Text);
                    PositionVariable = progressBar1.Value;
                    PositionVariable = (PositionVariable + PositionVariable2)/2;
                    PositionVariable = (PositionVariable + PositionVariable2 + PositionVariable3) / 3;
                    PositionVariable2 = PositionVariable;
                    PositionVariable3 = PositionVariable2;

                       if (Math.Abs(PositionVariable - PositionAnterior) < 2)
                            PositionVariable = PositionVariable2;
                    

                  //  label27.Text = "" + (9 - ((float.Parse(textBox_Flex.Text) - (int)numericUpDown6.Value) / ((int)(numericUpDown7.Value - numericUpDown6.Value) / 10)));

                    label27.Text = "" + (9 - ((PositionVariable - (int)numericUpDown6.Value) / ((int)(numericUpDown7.Value - numericUpDown6.Value) / 10)));


                    PositionActual = float.Parse(label27.Text);

                    PositionActual = (float)(0.5*PositionActual + 0.3*PositionAnterior+0.2*PositionAnterior2);
                //    if (Math.Abs(PositionVariable - PositionAnterior) < 2)
               //         PositionVariable = PositionAnterior;
                    PositionAnterior = PositionActual;
                    PositionAnterior2 = PositionAnterior;
                    
                    if(checkBox2.Checked)
                        trackBar1.Value = (9 - (int)PositionActual);

                   //     trackBar1.Value = 9 - ((progressBar1.Value - (int)numericUpDown6.Value)*10/ (int)(numericUpDown7.Value-numericUpDown6.Value));
                    label28.Text = ""+PositionActual;

                }
                catch
                { }


                chart1.Series["Series1"].Points.AddXY(i, PositionActual);
                i++;
                if (i >= 400)
                {
                    i = 0;
                    chart1.Series["Series1"].Points.Clear();
                }


            }

            catch { }
        }

        private void button2_Click(object sender, EventArgs e)
        {
        //    Background.currentState = Background.states.waiting;
        }

        private void button9_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar("Q");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar("Y");
        }

        private void button5_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar("U");
        }

        private void button4_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar("H");
        }

        private void button6_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar("J");
        }

        private void button7_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar("O");
        }

        private void button8_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar("P");
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
           label7.Text=""+trackBar1.Value;
        }

        private void trackBar1_ValueChanged(object sender, EventArgs e)
        {
            label7.Text = "" + trackBar1.Value;
            SerialCOM.enviar("" + trackBar1.Value);
        }

        private void button10_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar("{");
        }

        private void button11_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar("}");
        }

        private void button12_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar("V");
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            Tiempo = (int)numericUpDown1.Value;
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            AntFrec = (int)numericUpDown2.Value;
        }

        private void button13_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar(")");
        }

        private void button14_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar("(");
        }

        private void button15_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar("]");
        }

        private void button16_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar("[");
        }

        private void numericUpDown3_ValueChanged(object sender, EventArgs e)
        {
            Number = (int)numericUpDown3.Value;
        }

        private void numericUpDown4_ValueChanged(object sender, EventArgs e)
        {
            HojaDis = (int)numericUpDown4.Value;
        }

       void Resultados()
        {
            tabControl1.TabIndex = 3;
            label21.Text =""+ pointsAnts;
            label22.Text = "" + pointsSpider;
          //  label23.Text = "" + pointsWorms;
            label23.Text = "" +(pointsAnts+pointsSpider);
        }

       private void button18_Click(object sender, EventArgs e)
       {
           SerialCOM.enviar("A");
       }

       private void button17_Click(object sender, EventArgs e)
       {
           SerialCOM.enviar("W");
       }

       private void button19_Click(object sender, EventArgs e)
       {
           SerialCOM.enviar("Z");
       }

       private void numericUpDown6_ValueChanged(object sender, EventArgs e)
       {

       }

       private void numericUpDown7_ValueChanged(object sender, EventArgs e)
       {

       }

       private void button20_Click(object sender, EventArgs e)
       {
           SerialCOM.enviar("S");
       }

       private void numericUpDown5_ValueChanged(object sender, EventArgs e)
       {
           SpiderFrec = (int)numericUpDown5.Value;
       }

       private void Control_FormClosing(object sender, FormClosingEventArgs e)
       {
           MessageBox.Show("Cerrando");
           SerialCOM.enviar("*");
           if (serialPort1.IsOpen)
           {
               
               timer1.Stop();
             //  SerialCOM.enviar("*");
               serialPort1.DiscardInBuffer();
               serialPort1.DiscardOutBuffer();
               serialPort1.Dispose();
               serialPort1.Close();
               antsOut = true;
              StreamWriter SW = new StreamWriter("KBTest.txt");
               SW.Write("Puntaje Obtenido: " + (pointsAnts + pointsSpider));
               SW.Close();
           }
       }

       private void Control_FormClosed(object sender, FormClosedEventArgs e)
       {
       }

   }
}
