﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace InterfazRehabilitacion
{
    public partial class Control2 : Form
    {
        string RxString;
        string[] Palabras;

        public float roll;
        public float pitch;

        public Control2()
        {
            InitializeComponent();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            try
            {
                Palabras = SerialCOM.timerString(RxString);
                textBox_Pitch.Text = Palabras[0];
                textBox_Roll.Text = Palabras[1];

                try
                {
                    roll = float.Parse(textBox_Roll.Text);
                    pitch = float.Parse(textBox_Pitch.Text);
                }

                catch { }

            }
            
            catch
            {
            
            }
        }

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            try
            {
                if (serialPort1.IsOpen)
                    RxString = serialPort1.ReadLine();
                this.Invoke(new EventHandler(DisplayText));
            }
            catch
            {
                MessageBox.Show("ERROR");
            }
        }

        private void DisplayText(object sender, EventArgs e)
        {
            //   ReadSerial.Text = RxString;

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            SerialCOM.Checked();
        }

        private void Control2_Load(object sender, EventArgs e)
        {
            SerialCOM.cBPuertos = checkBox_Puerto;
            SerialCOM.cmbPuertos = comboBox_Puertos;
            SerialCOM.Puerto = serialPort1;
            SerialCOM.timer = timer1;
            SerialCOM.busca_puertos(ref comboBox_Puertos);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SerialCOM.enviar(textBox_Write.Text);
        }
    }
}
