using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace InterfazRehabilitacion
{
    public class Game1: Microsoft.Xna.Framework.Game
    {
        public Control form;

        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        //SoundEffect musicBackground;

        Texture2D BackgroundT;
        //Song musicBackground;
        Background Back = new Background();

        int Points;
        int PointsSpider;
        int PointsWorms;


        //***************************************************
        float AntTime;
        float SpiderTime;
        Random myRandom = new Random();

        int AntFrecuencia;
        int AntReferencia;

        int SpiderFrecuencia;
        int SpiderReferencia;

        bool spawning;
        //*****************************************************

        SpriteFont spriteFont;
 
        //Talloizquierdo
        Texture2D tallo2Texture;
        Rectangle tallo2Rectangle;
        //Barras

        int barraNumbers;
        int barraDistance;
        Texture2D barraTexture;
        Rectangle[] barraRectangle = new Rectangle[5];
        //Tallo
        Texture2D talloTexture;
        Rectangle talloRectangle;


        Random random = new Random();
        int[] Posiciones = new int[5];

        List<hormiga> ants = new List<hormiga>();
     
        List<gusano> worms = new List<gusano>();
        Texture2D gusanoTexture;
        Rectangle gusanoRectangle;
        const int gusanoSpeed = 1;

        List<araa> spiders = new List<araa>();

        //Hoja
        Texture2D hojaTexture;
        Rectangle hojaRectangle;
        Vector2 hojaPosition;
        Vector2 hojaOrigin = Vector2.Zero;
        float hojaRotation = 0.00f;
        //  float hojaScale=1.0f;
        Color hojaColor = Color.White;
        Rectangle hojaRectangle2;

      //  int hojaCaptura;
        public float hojaVariable;
        public float hojaAnterior;

        // The color data for the images; used for per pixel collision
        Color[] hojaTextureData;
        Color[] hormigaTextureData;
        Color[] gusanoTextureData;


        //Indicador
        Texture2D indicadorTexture;
        Rectangle indicadorRectangle;
       // Vector3 indicadorColor = new Vector3(100, 255, 0);
        bool indicadorVisible = false;

       // Alarma Alerta=new Alarma();


        Vector2 velocity;

        int ScreenWidth;
        int ScreenHeight;

        KeyboardState CurrentState;
        KeyboardState PreviousState;

       //public event EventHandler<EventArgs> OnExiting;
        protected override void OnExiting(Object sender, EventArgs args)
        {
            form.Close();
            base.OnExiting(sender, args);

            // Stop the threads
        }


        public Game1(Control form)
        {
            this.form = form;
            graphics = new GraphicsDeviceManager(this);
            graphics.PreferredBackBufferWidth = 800;
            graphics.PreferredBackBufferHeight = 600;
            Content.RootDirectory = "Content";
        }

        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        int[] posicionesD(int num, int dis)
        {
            int[] Posiciones = new int [num];
            switch (num)
            { 
                case 2:
                  Posiciones[0] = ScreenHeight * 1 / 2 - barraTexture.Height-dis*1/2;
                  Posiciones[1] = Posiciones[0] + barraTexture.Height + dis;
                break;

                case 3:
                  Posiciones[0] = ScreenHeight * 1 / 2 - barraTexture.Height*1/2;
                  Posiciones[1] = Posiciones[0] + barraTexture.Height + dis;
                  Posiciones[2] = Posiciones[0] - barraTexture.Height-dis;
                break;

                case 4:
                    Posiciones[0] = ScreenHeight * 1 / 2 - barraTexture.Height - dis * 1 / 2;
                    Posiciones[1] = Posiciones[0] + barraTexture.Height + dis;
                    Posiciones[2] = Posiciones[0] - barraTexture.Height - dis;
                    Posiciones[3] = Posiciones[0] + barraTexture.Height*2 + dis*2;
                break;

                case 5:
                    Posiciones[0] = ScreenHeight * 1 / 2 - barraTexture.Height * 1 / 2;                    
                    Posiciones[1] = Posiciones[0] + barraTexture.Height + dis;
                    Posiciones[2] = Posiciones[0] - barraTexture.Height - dis;
                    Posiciones[3] = Posiciones[0] + barraTexture.Height*2 + dis*2;
                    Posiciones[4] = Posiciones[0] - barraTexture.Height*2 - dis * 2;
                break;

            }

            return Posiciones;

        }


        protected override void LoadContent()
        {

            ScreenWidth = GraphicsDevice.Viewport.Width;
            ScreenHeight = GraphicsDevice.Viewport.Height;

           // musicBackground = Content.Load<Song>("Forest");
            //MediaPlayer.Play(musicBackground);
            MediaPlayer.IsRepeating = true;
            BackgroundT = Content.Load<Texture2D>("Trees");

            spriteBatch = new SpriteBatch(GraphicsDevice);
            spriteFont = Content.Load<SpriteFont>("SpriteFont1");

            Back.Load(Content);

            //Tallo2
            tallo2Texture = Content.Load<Texture2D>("tallo");
            tallo2Rectangle = new Rectangle(0, ScreenHeight - tallo2Texture.Height, tallo2Texture.Width, tallo2Texture.Height);

            int cacho = (ScreenHeight - tallo2Texture.Height) / 2;
            //Posiciones Barras
            Posiciones = new int[4] { cacho + ScreenHeight * 0 / 4, cacho + ScreenHeight * 1 / 4, cacho + ScreenHeight * 2 / 4, cacho + ScreenHeight * 3 / 4 };
            
            //barras
            barraTexture = Content.Load<Texture2D>("hojabarra2");

            //Tallo
            talloTexture = Content.Load<Texture2D>("tallo");
            talloRectangle = new Rectangle(ScreenWidth - talloTexture.Width, ScreenHeight - talloTexture.Height, talloTexture.Width, talloTexture.Height);

            //Hormiga
            hormiga.Load(Content);
            hormiga.distancia = barraTexture.Width + 20;
            hormigaTextureData = new Color[hormiga.Texture.Width * hormiga.Texture.Height];
            hormiga.Texture.GetData(hormigaTextureData);
            
            //Gusano                    
            gusanoTexture = Content.Load<Texture2D>("Cosa2");
            gusanoRectangle = new Rectangle(0, 0, gusanoTexture.Width, gusanoTexture.Height);

            gusanoTextureData = new Color[gusanoTexture.Width * gusanoTexture.Height];
            gusanoTexture.GetData(gusanoTextureData);

            //Hoja
            hojaTexture = Content.Load<Texture2D>("hoja2");
            hojaPosition = new Vector2(0, 0);
            hojaRectangle = new Rectangle(0, 0, hojaTexture.Width, hojaTexture.Height);
            hojaOrigin = new Vector2(hojaTexture.Width, hojaTexture.Height / 2);
            hojaPosition = new Vector2(ScreenWidth - talloTexture.Width / 2, ScreenHeight / 2);
            hojaTextureData = new Color[hojaTexture.Width * hojaTexture.Height];
            hojaTexture.GetData(hojaTextureData);

            indicadorTexture = Content.Load<Texture2D>("indicador");
            indicadorRectangle = new Rectangle(0, 0, indicadorTexture.Width * 2, indicadorTexture.Height * 2);
            
            velocity.X = 1f;
            velocity.Y = 1f;                            
        }
        
        protected override void UnloadContent()
        {
            
        }


        protected override void Update(GameTime gameTime)
        {
            CurrentState = Keyboard.GetState();

            Back.Update(gameTime);
            if (Back.SetupON)
            {
                Back.Timer = form.Tiempo;
                barraNumbers = form.Number;
                barraDistance = form.HojaDis;
                AntFrecuencia = form.AntFrec;
                SpiderFrecuencia =form.SpiderFrec;

                AntReferencia = 10000 / AntFrecuencia;
                SpiderReferencia = (form.Tiempo*1000) / SpiderFrecuencia-20000;

                Posiciones = posicionesD(barraNumbers, barraDistance);

                for(int i=0;i<barraNumbers;i++)
                barraRectangle[i] = new Rectangle(tallo2Texture.Width * 3 / 4, Posiciones[i], barraTexture.Width, barraTexture.Height);
            }

            if (Keyboard.GetState().IsKeyDown(Keys.Escape) && CurrentState != PreviousState)
            {
                this.form.Close();
                this.Exit();                
            }

            if (Back.GameON)            
            {
                     hojaVariable = form.PositionVariable;

                //Hoja
                Matrix hojaTransform =
        Matrix.CreateTranslation(new Vector3(-hojaOrigin, 0.0f)) *                    
        Matrix.CreateRotationZ(hojaRotation) *
        Matrix.CreateTranslation(new Vector3(hojaPosition, 0.0f));

                hojaRectangle2 = CollisionPerPixel.CalculateBoundingRectangle(new Rectangle(0, 0, hojaTexture.Width, hojaTexture.Height), hojaTransform);


               // if (Keyboard.GetState().IsKeyDown(Keys.Space) && CurrentState != PreviousState)
                if (spiders.Count == 0)
                    spawning = true;
                else
                    spawning = false;

                if (Back.Timer < 6)
                    spawning = false;


                if (spawning==true)
                {
                    if (AntTime > AntReferencia)
                    {
                        hormiga newHormiga = new hormiga();

                        float y = Posiciones[random.Next(0, barraNumbers)];
                        newHormiga.Position = new Vector2(hormiga.Texture.Width, y);
                        newHormiga.Speed = new Vector2(1, 1);
                        ants.Add(newHormiga);
                        AntTime = 0;
                    }

                    AntTime += gameTime.ElapsedGameTime.Milliseconds;
                }

                if (Keyboard.GetState().IsKeyDown(Keys.A) && CurrentState != PreviousState)
                {

                    gusano newGusano = new gusano();
                    newGusano.Load(Content);                              
                    newGusano.Position = new Vector2(ScreenWidth / 2+10, ScreenHeight);
                    worms.Add(newGusano);

                }

            //    if (Keyboard.GetState().IsKeyDown(Keys.Z) && CurrentState != PreviousState)
                if(SpiderTime>SpiderReferencia)
                {
                    araa newAraa = new araa();
                    newAraa.Load(Content);
                    newAraa.Position = new Vector2(newAraa.Texture.Width + 120, -400);


                    spiders.Add(newAraa);
                    SpiderTime = 0;
                }

                SpiderTime += gameTime.ElapsedGameTime.Milliseconds;


                for (int i = 0; i < ants.Count; i++)
                {
                    Matrix antsTransform =
             Matrix.CreateTranslation(new Vector3(-ants[i].Origin, 0.0f)) *
             Matrix.CreateRotationZ(ants[i].Rotation) *
             Matrix.CreateTranslation(new Vector3(ants[i].Position, 0.0f));

                    Rectangle antsRectangle = CollisionPerPixel.CalculateBoundingRectangle(new Rectangle(0, 0, hormiga.Texture.Width, hormiga.Texture.Height), antsTransform);


                    if (ants[i].CurrentState == hormiga.states.waiting || ants[i].CurrentState == hormiga.states.continuing)
                    {
                        if (antsRectangle.Intersects(hojaRectangle2))
                        {
                            if (CollisionPerPixel.IntersectPixels(antsTransform, hormiga.Texture.Width, hormiga.Texture.Height, hormigaTextureData,
                                hojaTransform, hojaTexture.Width, hojaTexture.Height, hojaTextureData))
                            {
                                ants[i].Collision = true;                                
                                ants[i].Speed.X = (float)(1 * Math.Cos(hojaRotation) + 0.5);
                                ants[i].Speed.Y = (float)(1 * Math.Sin(hojaRotation) - 1);

                                //Enderezarse
                                if (ants[i].Rotation < hojaRotation)
                                    ants[i].Rotation += 0.02f;
                                else if (ants[i].Rotation > hojaRotation)
                                    ants[i].Rotation -= 0.02f;

                                //Curva hoja
                                if (ants[i].Position.X > ScreenWidth - talloTexture.Width - 130)
                                {
                                    ants[i].Rotation += 0.02f;
                                }

                            }
                            else ants[i].Collision = false;
                        }
                        else ants[i].Collision = false;

                        if (!ants[i].Collision && ants[i].CurrentState == hormiga.states.continuing)
                        {
                            if (ants[i].Rotation < 0)
                                ants[i].Rotation += 0.02f;
                            else if (ants[i].Rotation > 0)
                                ants[i].Rotation -= 0.02f;

                            ants[i].Speed.X = 0.3f;
                            ants[i].Speed.Y = 1.5f;
                        }
                    }

                    ants[i].Update(gameTime);

                    if (ants[i].Position.Y > Window.ClientBounds.Height - hormiga.Texture.Height
                        || ants[i].Position.X < 0)
                    {
                        ants.RemoveAt(i);
                        i--;
                    }

                    else if (ants[i].Position.X > Window.ClientBounds.Width - hormiga.Texture.Width * 2 && ants[i].Collision)
                    {
                        ants.RemoveAt(i);
                        i--;
                        Points++;
                    }
                    
                }


                for (int i = 0; i < worms.Count; i++)
                {

                    worms[i].Update(gameTime);

                   Matrix wormTransform =
                   Matrix.CreateTranslation(new Vector3(Vector2.Zero, 0.0f)) *                               
                   Matrix.CreateRotationZ(0) *
                   Matrix.CreateTranslation(new Vector3(worms[i].Position, 0.0f));

                            if (CollisionPerPixel.IntersectPixels(wormTransform, worms[i].Texture.Width, worms[i].Texture.Height, worms[i].TextureData,
                       hojaTransform, hojaTexture.Width, hojaTexture.Height, hojaTextureData))
                            {
                                worms[i].Collision = true;
                            }

                            if (hojaRotation <= -0.25)
                                worms[i].Limit = true;
                            else
                                worms[i].Limit = false;


                    if (worms[i].Collision)
                    worms[i].Position.Y = -1 * float.Parse("" + (Math.Sin(hojaRotation) * (hojaTexture.Width - 20) + Math.Pow(Math.Sin(hojaRotation),2)*2)) + hojaPosition.Y;

                    if (worms[i].CurrentState == gusano.states.dissapearing)                  
                    {
                        if (worms[i].Win == true)
                            PointsWorms++;

                           worms.RemoveAt(i);

                        i--;
                    }

                }

                for (int i = 0; i < spiders.Count; i++)
                {
                    spiders[i].Update(gameTime);

                    Matrix spiderTransform =
             Matrix.CreateTranslation(new Vector3(Vector2.Zero, 0.0f)) *                      
             Matrix.CreateRotationZ(0) *
             Matrix.CreateTranslation(new Vector3(spiders[i].Telaraa.Posicion1, 0.0f));

                    if (CollisionPerPixel.IntersectPixels(spiderTransform, spiders[i].Telaraa.Texture1.Width, spiders[i].Telaraa.Texture1.Height, spiders[i].TelaTextureData,
    hojaTransform, hojaTexture.Width, hojaTexture.Height, hojaTextureData))
                    {
                        spiders[i].Collision = true;
                    }

                    
                    if(hojaRotation>=0.20)
                        spiders[i].Limit = true;
                    else
                        spiders[i].Limit = false;
                    

                    if (spiders[i].Collision)
                   spiders[i].Telaraa.Posicion1.Y =-1*float.Parse(""+Math.Sin(hojaRotation)*hojaTexture.Width)+hojaPosition.Y-spiders[i].Telaraa.Texture1.Height;


                    //  if (Keyboard.GetState().IsKeyDown(Keys.X) && CurrentState != PreviousState)
                    if (spiders[i].CurrentState == araa.states.dissapearing)
                    {
                        if (spiders[i].Win == true)
                            PointsSpider++;

                        spiders.RemoveAt(i);
                        i--;
                    }
                }
                ///////////////////////////// ROTACION //////////////////////////


                if (Keyboard.GetState().IsKeyDown(Keys.Q))
                {
                    hojaRotation += 0.02f;
                }
                if (Keyboard.GetState().IsKeyDown(Keys.W))
                {
                    hojaRotation -= 0.02f;
                }

                hojaRotation = (300-hojaVariable) *2* 0.67F / 70F + 0.67F ;
                if (hojaRotation < -0.67F)
                    hojaRotation = -0.67f;

                if (hojaRotation > 0.67F)
                    hojaRotation = 0.67f;             
            
             Back.Timer -= (float)gameTime.ElapsedGameTime.TotalSeconds;                         
            }               
            PreviousState = CurrentState;
            if (Back.currentState == InterfazRehabilitacion.Background.states.ending)
            {
               form.pointsAnts=Points;
               form.pointsSpider = PointsSpider;
               form.pointsWorms = PointsWorms;
               form.Fin = true;
            }
            base.Update(gameTime);
            }
       
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Back.backColor);
            spriteBatch.Begin();
                        
            if (Back.GameON == true)
            {
                spriteBatch.Draw(BackgroundT, new Rectangle(0, 0, ScreenWidth, ScreenHeight), Color.White);
                spriteBatch.DrawString(spriteFont, "Timer:" + (int)Back.Timer, new Vector2(500, 0), Color.White);
                spriteBatch.DrawString(spriteFont, "Puntaje: " + Points, new Vector2(300, 0), Color.White);

                spriteBatch.Draw(tallo2Texture, tallo2Rectangle, Color.White);

                for(int i=0;i<barraNumbers;i++)
                spriteBatch.Draw(barraTexture, barraRectangle[i], Color.White);

                spriteBatch.Draw(talloTexture, talloRectangle, Color.White);
                spriteBatch.Draw(hojaTexture, hojaPosition, hojaRectangle, Color.White, hojaRotation, hojaOrigin, 1.0f, SpriteEffects.None, 0f);
               
                foreach (hormiga H in ants)
                {
                     H.Draw(spriteBatch);
                }

                foreach (gusano G in worms)
                {
                   G.Draw(spriteBatch);
                }

                foreach (araa A in spiders)
                {
                    A.Draw(spriteBatch);
                }

                if (indicadorVisible)
                {
                    spriteBatch.Draw(indicadorTexture, new Rectangle(400, 100, indicadorRectangle.Width * 2, indicadorRectangle.Height * 2),
                        indicadorRectangle, Color.White);
                    spriteBatch.Draw(indicadorTexture, new Rectangle(400, 450, indicadorRectangle.Width * 2, indicadorRectangle.Height * 2),
                        indicadorRectangle, Color.White);
                }
            }            
            Back.Draw(spriteBatch);
                spriteBatch.End();

            base.Draw(gameTime);
        }        
  }
}
