﻿using System;

using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content;

namespace InterfazRehabilitacion
{
    class hormiga
    {
        public static Texture2D Texture;
        public static Texture2D Texture2;
        public static Rectangle Rectangle;
        public Vector2 Position;
        public Vector2 Speed=new Vector2(2f,0f);
        public float Rotation;
        public bool Collision;
        public float Timer=0;
        public Vector2 Origin=Vector2.Zero;
        public static int distancia;
        //public int position;

        
        public enum states
        {
            walking, waiting, returning,continuing
        }

        public states CurrentState= states.walking;


        public static void Load(ContentManager Content)
        {
            hormiga.Texture = Content.Load<Texture2D>("CosaHormiga");
            hormiga.Texture2 = Content.Load<Texture2D>("CosaHormigaEspejo");
            hormiga.Rectangle = new Rectangle(0, 0, hormiga.Texture.Width, hormiga.Texture.Height);
        }

        public void Update(GameTime gameTime)
        {
            Position += new Vector2(Speed.X, Speed.Y);

            switch(CurrentState)
            { 
                case states.walking:
                    this.Speed = new Vector2(2f, 0f);
                    if (this.Position.X >= distancia)
                    {
                        CurrentState = states.waiting;
                    }
                    break;

                case states.waiting:
                    this.Speed = new Vector2(0, 0);
                    this.Timer += (float)gameTime.ElapsedGameTime.TotalSeconds;
                    if (this.Collision)
                    {
                        CurrentState = states.continuing;
                        this.Timer = 0;
                    }

                    if (Timer>2)
                    {
                        CurrentState = states.returning;
                        this.Timer=0;
                    }
                    break;

                case states.returning:
                    this.Speed = new Vector2(-2f, 0f);
                    break;

                case states.continuing:
                    break;
            }
        }

        public void Draw(SpriteBatch spriteBatch)
        {
            if (CurrentState == states.returning)
                spriteBatch.Draw(hormiga.Texture2,this.Position, hormiga.Rectangle, Color.White, this.Rotation, Vector2.Zero, 1.0f, SpriteEffects.None, 0.0f);
            else
                spriteBatch.Draw(hormiga.Texture, this.Position,hormiga.Rectangle, Color.White, this.Rotation, Vector2.Zero, 1.0f, SpriteEffects.None, 0.0f);
        }

    }
}
