﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content;

namespace InterfazRehabilitacion
{
    class Indicador
    {
        static Texture2D texture;
        static Rectangle rectangle;
        static Vector2 position;
        static Color color = Color.White;

        enum states
        { 
        hiding,uping,downing,finishing
        }
        
        states Currentstate=states.hiding;

        void Load(ContentManager Content)
        {
            Indicador.texture=Content.Load<Texture2D>("indicador");
            Indicador.rectangle = new Rectangle(0, 0, Indicador.texture.Width, Indicador.texture.Height);
        }

        void Update(GameTime gameTime)
        {
            switch (Currentstate)
            { 
                case states.hiding:
                    break;
                case states.uping:
                    Indicador.position = new Vector2(300, 100);
                    break;
                case states.downing:
                    Indicador.position = new Vector2(300, 500);
                    break;
                case states.finishing:
                    break;                  

            }
        }

        void Draw(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(Indicador.texture, new Rectangle((int)Indicador.position.X, (int)Indicador.position.Y, Indicador.rectangle.Width, Indicador.rectangle.Height)
                , Indicador.color);
        }
    }
}
