﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace InterfazRehabilitacion
{
    public partial class VentanaUsuario : Form
    {
        public VentanaUsuario()
        {
            InitializeComponent();
        }

        StreamWriter SW;
        StreamReader SR;
        string ruta = "Usuarios.txt";
        List<string> cadenas;
        Reporte Cosa1 = new Reporte();
        string[,] MM;
        //string nombre;
        void metodocosa()
        {
            Cosa1.nombreUsuario = comboBox1.Text + ".txt";
            MM = Cosa1.leer();
        }

        void otracosa()
        {
            Cosa1.nombreUsuario = comboBox1.Text + ".txt";
            Cosa1.agregar();
        }


        //static string filename=@"Usuarios";
        DateTime fecha = DateTime.Today;
        public static int puntaje;
        // static FileStream fs = new FileStream(filename, FileMode.OpenOrCreate,FileAccess.Write);
        // static BinaryWriter BW = new BinaryWriter(fs);

        // //
        void escribir(string A, string texto, bool B)
        {
            SW = new StreamWriter(A, B);
            SW.WriteLine(texto);
            SW.Close();
        }

        void escribirCadenas(string A, List<string> joins)
        {
            //  SW = new StreamWriter(A,false);
            //  SW.WriteLine("");
            //  SW.Close();
            SW = new StreamWriter(A, false);
            foreach (string s in joins)
            {
                SW.WriteLine(s);
            }
            SW.Close();
        }

        public string leer(string A)
        {
            SR = new StreamReader(A);
            string cadena = SR.ReadToEnd();
            SR.Close();
            return cadena;
        }

        public string[] spliter(string S)
        {
            string[] splits = S.Split('\n');
            return splits;
        }



        // //




        private void button4_Click(object sender, EventArgs e)
        {
            cadenas.Add(textBox1.Text);
            comboBox2.Items.Clear();
            foreach (string s in cadenas)
            {
                comboBox2.Items.Add(s);
            }
        }

        //private void VentanaInicio_Load(object sender, EventArgs e)
        //{
        //    cadenas = new List<string>(spliter(leer(ruta)));
        //    MessageBox.Show("" + cadenas.Count);
        //    cadenas.RemoveAt(cadenas.Count);
        //    comboBox1.Items.Clear();
        //    foreach (string s in cadenas)
        //    {
        //        comboBox1.Items.Add(s);
        //    }

        //}

        private void button3_Click(object sender, EventArgs e)
        {
            cadenas.Remove(comboBox2.Text);
            comboBox2.Items.Clear();
            foreach (string s in cadenas)
            {
                comboBox2.Items.Add(s);
            }
            comboBox2.Text = "";
        }

        //private void VentanaInicio_FormClosed(object sender, FormClosedEventArgs e)
        //{
        //    escribirCadenas(ruta, cadenas);
        //}

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
          

            if (tabControl1.SelectedIndex == 0)
            {
                comboBox1.Items.Clear();
                foreach (string s in cadenas)
                {
                    comboBox1.Items.Add(s);
                }
                escribirCadenas(ruta, cadenas);
            }

            else if (tabControl1.SelectedIndex == 1)
            {
                comboBox2.Items.Clear();
                foreach (string s in cadenas)
                {
                    comboBox2.Items.Add(s);
                }
            }
        }

        public class Reporte
        {
            public string nombreUsuario;
            public List<DatoUsuario> informacion = new List<DatoUsuario>();
            StreamWriter SWUsuario;
            StreamReader SRUsuario;

            public void agregar()
            {
                informacion.Add(new DatoUsuario(1, new DateTime(2012, 12, 20), 20));
            }

            public void escribir(string mensaje)
            {
                SWUsuario = new StreamWriter(nombreUsuario);
                SWUsuario.WriteLine(mensaje);
                SWUsuario.Close();
            }

            public string[,] leer()
            {
                //  List<string[]> matrix=null;
                //string[] todo;
                int i, j = 0;
                SRUsuario = new StreamReader(nombreUsuario);
                string[,] matrix = new string[3, 30];
                while (SRUsuario.EndOfStream != true && j < 30)
                {
                    string[] line = SRUsuario.ReadLine().Split(',');

                    for (i = 0; i < 3; i++)
                        matrix[i, j] = line[i];
                    j++;
                }


                //  todo = SRUsuario.ReadToEnd().Split('.');
                //  foreach (string s in todo)
                // {
                //      matrix.Add(s.Split(','));
                //  }

                //   string a = matrix.ElementAt<string[]>(1)[0];


                SRUsuario.Close();

                return matrix;
            }


        }

        public class DatoUsuario
        {
            public int num = 0;
            public DateTime fecha = new DateTime(2014, 1, 1);
            public float puntaje = 0;

            public DatoUsuario(int num, DateTime fecha, float puntaje)
            {
                this.num = num;
                this.fecha = fecha;
                this.puntaje = puntaje;
            }

            public string DToString()
            {
                string S = num + "," + fecha.ToString("d") + "," + puntaje;
                return S;
            }

        }

        //private void button5_Click(object sender, EventArgs e)
        //{
        //    //metodocosa();
        //    Cosa1.nombreUsuario = comboBox1.Text + ".txt";
        //    Cosa1.agregar();
        //    MessageBox.Show("" + Cosa1.informacion.ElementAt<DatoUsuario>(0).DToString());
        //    Cosa1.escribir("" + Cosa1.informacion.ElementAt<DatoUsuario>(0).DToString());
        //    //monthCalendar1.AddBoldedDate(Cosa.informacion.ElementAt<DatoUsuario>(0).fecha);
        //}

        private void button1_Click(object sender, EventArgs e)
        {
           
            if (comboBox1.Text != "")
            {
             this.Visible = false;
              VentanaInicio otraCosa = new VentanaInicio();
              otraCosa.nombre = comboBox1.Text;
              otraCosa.Show();
            }
            else
                MessageBox.Show("Por favor elija un nombre de usuario");
        }

        private void VentanaUsuario_Load(object sender, EventArgs e)
        {
            this.Location = new Point(300, 200);
            cadenas = new List<string>(spliter(leer(ruta)));
            cadenas.Remove("\r");
            cadenas.Remove("");
            comboBox1.Items.Clear();
            foreach (string s in cadenas)
            {
                comboBox1.Items.Add(s);
            }
         //   dateTimePicker1.Value = DateTime.Today;
        //  label2.Text = "Hola " + nombre + ", bienvenido a tu sesión de hoy:\n" + dateTimePicker1.Value.ToString("D");
        }

        private void VentanaUsuario_FormClosed(object sender, FormClosedEventArgs e)
        {
            escribirCadenas(ruta, cadenas);
        }

   }
}
