﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

namespace InterfazRehabilitacion
{
    class gusano
    {
       public Texture2D Texture;
       Texture2D TextureNormal;
       public Vector2 Position;
       public Vector2 Speed = new Vector2(2, 2);
       public bool Collision;
       public bool Limit;
       public float Timer = 10;
       public bool Save;

       public bool Win = false;

       Alarma Alerta = new Alarma();


       public Color[] TextureData;


       public enum states
       {
           warning, uping, searching, pulling, breaking, biting, dissapearing
       }

       public states CurrentState = states.warning;

       public gusano()
       {
           this.Position = new Vector2(0, 200);
       }


       public void Load(ContentManager Content)
       {
           TextureNormal = Content.Load<Texture2D>("Cosa22");
           this.Texture = TextureNormal;
           TextureData = new Color[TextureNormal.Width * TextureNormal.Height];
           TextureNormal.GetData(TextureData);

           Alerta.Load(Content);
           Alerta.Count = 4;
       }

       public void Update(GameTime gameTime)
       {
           switch (CurrentState)
           {
               case states.warning:
                   Alerta.Update(gameTime);
                   if (Alerta.Finish == true)
                   CurrentState = states.uping;
                   break;

               case states.uping:
                   if (this.Position.Y < 250)
                       this.Position.Y -= this.Speed.Y;
                   else
                   {
                        CurrentState = states.searching;
                   //    this.Telaraña.Posicion1.X = this.TextureNormal.Width + this.TextureNormal.Width / 2 + 90;
                   //    this.Telaraña.Posicion1.Y = 150;

                   }
                   break;

               case states.searching:
                   this.Position.Y -= (int)Speed.Y;
                   if (this.Collision == true)
                       CurrentState = states.pulling;
                   break;

               case states.pulling:

                   this.Timer -= (float)gameTime.ElapsedGameTime.TotalSeconds;
                   if (Timer <= 0)
                   {
                       Save = true;
                   }
                  if (this.Limit == true)
                   {
                      CurrentState = states.biting;
                       Timer = 2;
                   }
                   else if (this.Save == true)
                   {
                       CurrentState = states.breaking;
                   }
                   break;

               case states.biting:
                   this.Timer -= (float)gameTime.ElapsedGameTime.TotalSeconds;
                   if (Timer <= 0)
                   {
                       Win = false;
                       CurrentState = states.dissapearing;
                   }
                   break;

               case states.breaking:
                   this.Position.Y -= this.Speed.Y;

                   if (Position.Y > 600)
                   {
                       Win = true;
                       CurrentState = states.dissapearing;
                   }
                   break;

               case states.dissapearing:
                   break;


           }
       }

       public void Draw(SpriteBatch spriteBatch)
       {

           switch (CurrentState)
           {
               case states.warning:
               Alerta.Draw(spriteBatch);
                   break;

               case states.uping:
                   this.Texture = TextureNormal;
                   spriteBatch.Draw(this.Texture, this.Position, null, Color.White);
                   break;

               case states.searching:
                   spriteBatch.Draw(this.Texture, this.Position, null, Color.White);
                   break;

               case states.pulling:
                //   this.Texture = TexturePull;
                  spriteBatch.Draw(this.Texture, this.Position, null, Color.White);
                   break;

               case states.biting:
                  // this.Texture = TextureBite;
                   spriteBatch.Draw(this.Texture, this.Position, null, Color.White);
                   break;

               case states.breaking:
                  // this.Texture = TextureBad;
                   spriteBatch.Draw(this.Texture, this.Position, null, Color.White);
                   break;

               case states.dissapearing:
                   break;

           }

       }




    }
}
